
class GaussianEliminationPivot{
	public double[] solve(double[][] a) {

		int n=a.length;
		int m=a[0].length;

		//pivot exchange
		for(int i=0;i<n;i++){
			int diag=i;
			double max=Math.abs(a[i][i]);
			for(int j=i+1;j<n;j++) {
				if(i==j)continue;
				if(max<Math.abs(a[j][i])) {
					max=Math.abs(a[j][i]);
					diag=j;
				}
			}

			if(i==diag)continue;
			for(int j=0;j<m;j++) {
				double work=a[i][j];
				a[i][j]=a[diag][j];
				a[diag][j]=work;
			}
		}

		//forward elimination
		for(int i=0;i<n;i++) {
			for(int j=i+1;j<n;j++) {
				double alpha=a[j][i]/a[i][i];
				for(int k=0;k<m;k++) {
					a[j][k]-=alpha*a[i][k];
				}
			}
		}

		//backward substitution
		double[] x=new double[n];

		x[n-1]=(a[n-1][n])/a[n-1][n-1];

		for(int i=n-2;i>=0;i--) {
			x[i]=a[i][n];
			for(int j=n-1;j>=i+1;j--) {
				x[i]-=(a[i][j]*x[j]);
			}
			x[i]/=a[i][i];
		}

		return x;
	}
}


public class Mat_011 {
	public static void main(String[] args) {
/*
		double[][] a= {
				{ 6.0, 5.0, 4.0, 8.0},
				{12.0,13.0,10.0,16.0},
				{18.0,21.0,17.0,27.0}
		};
*/
		double[][] a= {
				{175000.0, -70000.0,   0.0},
				{-70000.0,  70000.0,10000.0},
		};



		double[] x;
		int n=a.length;


		for(int i=0;i<n;i++) {
			for(int j=0;j<n-1;j++) {
				System.out.format("%5.1f*x[%2d] + ",a[i][j],j);
			}
			System.out.format("%5.1f*x[%2d] = ",a[i][n-1],n-1);
			System.out.format("%5.1f\n",a[i][n]);
		}
		System.out.println();

		GaussianEliminationPivot ge=new GaussianEliminationPivot();

		x=ge.solve(a);

		System.out.println("answer:");
		for(int i=0;i<n;i++){
			System.out.format("x[%2d]=%5.5f\n",i,x[i]);
		}

	}
}
